{ config, lib, pkgs, options, ... }:

with lib;
let
  cfg = config.modules.services.mysql;
in {
  options.modules.services.mysql = {
    enable = mkOption {
      type = types.bool;
      default = false;
    };
  };

  config = mkIf cfg.enable {
    services.mysql = {
      enable = true;
      package = pkgs.mariadb_114;

      settings = {
        mysqld = {
          max_allowed_packet = "128M";
        };
        client = {
          max_allowed_packet = "128M";
        };
      };
    };
  };
}
